
Ruby - Bug #19381

SEGV - ivars, both Ubuntu & Windows

01/26/2023 03:32 PM - MSP-Greg (Greg L)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 3.3.0dev (2023-01-26T07:31:08Z

master 6422fef90c) [x86_64-linux]

Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:

UNKNOWN, 3.2: UNKNOWN

Description

I've used code similar to the below for a long time.  When max is set to 50, it runs.  When max is set to 51, it SEGV faults.

Rubies tested:

ruby 3.3.0dev (2023-01-26T07:31:08Z master 6422fef90c) [x86_64-linux]

ruby 3.3.0dev (2023-01-26T07:31:08Z master 6422fef90c) [x64-mingw-ucrt]

ruby 3.3.0dev (2023-01-26T07:31:08Z master 6422fef90c) [x64-mswin64_140]

I suspect it involves the changes in https://github.com/ruby/ruby/pull/7183 'Limit maximum number of IVs on a shape'

module Test

  class << self

    def run

      max = 51

      (1..max).each do |v|

        instance_variable_set("@iv#{v}".to_sym, nil)

      end

    end

  end

end

Test.run

puts Test.instance_variables

Related issues:

Related to Ruby - Bug #19334: Defining many instance variables and accessing ... Closed

History

#1 - 01/26/2023 03:48 PM - luke-gru (Luke Gruber)

Recently there was a change to object shapes, and there were no tests made for that commit. I think they'll add some now :)

The change is here, made on Jan. 25: https://github.com/ruby/ruby/commit/78fcc9847a9db6d42c8c263154ec05903a370b6b

It looks like objects other than T_OBJECTs are being set to TOO_COMPLEX shape.

EDIT: oh sorry I didn't see you added the PR in your ticket MSP-Greg.

#2 - 01/26/2023 03:52 PM - MSP-Greg (Greg L)

Thanks.  That's the commit for the PR I listed (#7183).  I should have listed it...

#3 - 01/26/2023 04:04 PM - tenderlovemaking (Aaron Patterson)

Thanks.  I'm going to revert the commit for now.  ����♀️

#4 - 01/26/2023 04:09 PM - Eregon (Benoit Daloze)

- Related to Bug #19334: Defining many instance variables and accessing them is slow in Ruby 3.2.0 added

#5 - 02/10/2023 06:20 PM - jeremyevans0 (Jeremy Evans)

- Status changed from Open to Closed

Fixed by 28da9909849dc02abe74de8170fe4036534361ba
